package com.lianqin360.aresrctbasic.modules.cookiemanager;


import android.content.Context;
import android.util.Log;
import android.webkit.CookieManager;
import android.webkit.CookieSyncManager;

import java.util.HashMap;

/**
 * Created by Spencer on 16/6/16.
 */
public class MyCookieManager {
    private  CookieManager cookieManager;
    private static MyCookieManager mCM;

    private MyCookieManager(Context context){
        CookieSyncManager.createInstance(context);
        cookieManager= CookieManager.getInstance();
        cookieManager.setAcceptCookie(true);
    }
    public static MyCookieManager getInstance(Context context){
        if(mCM ==null){
            mCM =  new MyCookieManager(context);
        }
        return mCM;
    }
    public  void removeAllCookie(){
        cookieManager.removeAllCookie();
    }
    public  void removeSessionCookie(){
        cookieManager.removeSessionCookie();
    }
    public void setAcceptCookie(Boolean isAccept){
        cookieManager.setAcceptCookie(isAccept);
    }
    public void setCookie(String url,String key, String value){
        cookieManager.setCookie(url,key+"="+value);
    }
    public void syncCookie(){
        CookieSyncManager.getInstance().sync();
    }
    public HashMap<String,String> cookiesFroURL(String url){
        String[] cookies = cookieManager.getCookie(url).split("; ");
        HashMap<String,String> cookieJar = new HashMap<>();
        for(String cookie : cookies){
            String[] v = cookie.split("=");
            cookieJar.put(v[0],v[1]);
        }
        return cookieJar;
    }
}
