package com.lianqin360.aresrctbasic.modules.cookiemanager;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.WritableArray;
import com.facebook.react.bridge.WritableMap;

import java.util.HashMap;
import java.util.Set;

/**
 * Created by Spencer on 16/6/16.
 */
public class ReactCookieManager  extends ReactContextBaseJavaModule {

    private static final String REACT_CLASS = "RCTCookieManager";
    private MyCookieManager myCookieManager;
    public ReactCookieManager(ReactApplicationContext reactContext) {

        super(reactContext);
        myCookieManager = MyCookieManager.getInstance(reactContext);
    }

    @Override
    public String getName() {
        return REACT_CLASS;
    }
    @ReactMethod
    public void setCookie(String url,String name,String value){
        myCookieManager.setCookie(url,name,value);
    }
    @ReactMethod
    public  void removeAllCookie(){
        myCookieManager.removeAllCookie();
    }
    @ReactMethod
    public  void removeSessionCookie(){
        myCookieManager.removeSessionCookie();
    }
    @ReactMethod
    public void setAcceptCookie(Boolean isAccept){
        myCookieManager.setAcceptCookie(isAccept);
    }
    @ReactMethod
    public void syncCookie(){
        myCookieManager.syncCookie();
    }
    @ReactMethod
    public void cookies(){
        //myCookieManager.syncCookie();
    }
    @ReactMethod
    public void cookiesForURL(String url, Callback callback){
        HashMap<String,String> cookies = myCookieManager.cookiesFroURL(url);
        WritableMap map = Arguments.createMap();
        Set<String> names = cookies.keySet();
        for(String name :names){
            WritableMap v = Arguments.createMap();

            v.putString("name",name);
            v.putString("value",cookies.get(name));
            map.putMap(name,v);
        }
        callback.invoke(map);
    }

}
