package com.lianqin360.aresrctbasic.modules.download;

import android.app.DownloadManager;
import android.content.Context;
import android.net.Uri;
import android.os.Environment;

import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import javax.annotation.Nullable;


/**
 * Created by Spencer on 2017/1/16.
 */

public class ReactDownloadManager extends ReactContextBaseJavaModule{
    ReactApplicationContext mContext;
    private DownloadManager downloadManager;
    public ReactDownloadManager(ReactApplicationContext reactContext) {
        super(reactContext);
        mContext = reactContext;
    }

    /**
     * @return the name of this module. This will be the name used to {@code require()} this module
     * from javascript.
     */
    @Override
    public String getName() {
        return "DownloadManager";
    }

    @Nullable
    @Override
    public Map<String, Object> getConstants() {
        return new HashMap<String, Object>() {
            {
                put("NETWORK_MOBILE", DownloadManager.Request.NETWORK_MOBILE);
                put("NETWORK_WIFI", DownloadManager.Request.NETWORK_WIFI);
                put("VISIBILITY_HIDDEN", DownloadManager.Request.VISIBILITY_HIDDEN);
                put("VISIBILITY_VISIBLE_NOTIFY_COMPLETED", DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
                put("VISIBILITY_VISIBLE_NOTIFY_ONLY_COMPLETION", DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_ONLY_COMPLETION);
            }
        };
    }

    @ReactMethod
    public void setAllowedNetworkTypes(int networkTypes){

    }
    @ReactMethod
    public void download(ReadableMap downloadConfig, Promise promise){
        DownloadManager downloadManager;
        String downloadUrl = downloadConfig.getString("url");
        int allowedNetworkTypes = downloadConfig.getInt("allowedNetworkTypes");
        int notificationVisibility = downloadConfig.getInt("notificationVisibility");
        String path = downloadConfig.getString("path");
        File file = new File(Environment.getExternalStorageDirectory(), path);
        file.mkdirs();
        downloadManager = (DownloadManager) mContext.getSystemService(Context.DOWNLOAD_SERVICE);
        Uri uri = Uri.parse(downloadUrl);
        DownloadManager.Request request = new DownloadManager.Request(uri);
        //设置
        request.setAllowedNetworkTypes(allowedNetworkTypes);
        request.setNotificationVisibility(notificationVisibility);

        request.setDestinationUri(Uri.fromFile(file));


        long reference = downloadManager.enqueue(request);
    }
}
