package com.lianqin360.aresrctbasic.views.IWebView;

import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.net.http.SslError;
import android.os.Build;
import android.util.Log;
import android.webkit.SslErrorHandler;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import java.net.MalformedURLException;
import java.net.URL;


public class MyWebViewClient extends WebViewClient{
    private MyWebView mWebView;
    public MyWebViewClient(MyWebView webView){
        mWebView = webView;
    }
    @Override
    public void onReceivedError(WebView view, int errorCode,
                                String description, String failingUrl) {
        Log.e("neterror","neterror");
    }

    @Override
    public void onReceivedSslError(WebView view, SslErrorHandler handler, SslError error){
        //handler.cancel();
        handler.proceed();//
        //handleMessage(Message msg);
    }

    @Override
    public boolean shouldOverrideUrlLoading(WebView view, WebResourceRequest request) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            return handleUri(view,request.getUrl());
        } else {
            return true;
        }
    }
    private boolean handleUri(WebView view,Uri uri){
        String host =  uri.getHost();
        if(host.equals("ares-webview")){
            mWebView.delegate.onInvoke(uri.getPath(),uri.getQuery());
        }else if(host.equals("http")||host.equals("https")||host.equals("ftp")){
            view.loadUrl(uri.toString());
        }else {
            Intent intent = new Intent(Intent.ACTION_VIEW,uri);
            view.getContext().startActivity(intent);
        }
        return  true;
    }
    @Override
    public boolean shouldOverrideUrlLoading(WebView view, String url) {
        return handleUri(view,Uri.parse(url));
    }

    @Override
    public void onPageStarted(WebView view, String url, Bitmap favicon) {
        // TODO Auto-generated method stub
        super.onPageStarted(view, url, favicon);
        mWebView.delegate.onPageStarted(mWebView,url);
    }

    @Override
    public void onPageFinished(WebView view, String url) {
        // TODO Auto-generated method stub
        super.onPageFinished(view, url);
        mWebView.delegate.onPageFinished(mWebView,url);
    }
}

