package com.lianqin360.aresrctbasic.views.IWebView;


import android.util.Log;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactContext;
import com.facebook.react.bridge.ReadableArray;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.common.MapBuilder;
import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;
import com.facebook.react.uimanager.annotations.ReactProp;
import com.lianqin360.aresrctbasic.jsmodules.WebViewJsModule;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import javax.annotation.Nullable;

/**
 * Created by Spencer on 16/6/20.
 */
public class ReactWebViewLayoutManager extends SimpleViewManager<WebViewLayout>  {
    @Override
    public String getName() {
        return "RCTAresWebView";
    }
    public static final int GO_BACK = 1;
    public static final int LOAD_URL = 2;
    public static final int LOAD_JS = 3;
    public static final int RELOAD = 4;
    public static final int SET_PROP = 5;

    @Override
    protected WebViewLayout createViewInstance(ThemedReactContext reactContext) {
        WebViewLayout viewLayout = new WebViewLayout(reactContext);
        return viewLayout;

    }
    @ReactProp(name = "source")
    public void setSource(WebViewLayout view, @Nullable ReadableMap source) {
        if (source != null) {
            if (source.hasKey("uri")) {
                String url = source.getString("uri");
                view.loadUrl(url);
            }else if(source.hasKey("html")){
                view.loadHtml(source.getString(("html")));
            }
        }

    }
    @ReactProp(name = "onShouldStartLoadWithRequestKey")
    public void setOnShouldStartLoadWithRequestKey(WebViewLayout view,String key){
       view.setOnShouldStartLoadWithRequestListenerKey(key);
    }
    @ReactProp(name= "onPageFinishedKey")
    public void setOnPageFinishedKey(WebViewLayout view,String key){
        view.setOnPageFinishedListenerKey(key);
    }
    @ReactProp(name= "onPageStartedKey")
    public void setOnPageStartedKey(WebViewLayout view,String key){
        view.setOnPageStartedListenerKey(key);
    }
    @ReactProp(name= "onProgressChangedKey")
    public void setOnProgressChangedKey(WebViewLayout view,String key){
        view.setOnProgressChangedListenerKey(key);
    }
    @ReactProp(name= "onInvokeKey")
    public void setOnInvokeKey(WebViewLayout view,String key){
        view.setOnInvokeListenerKey(key);
    }

    @Override
    public Map<String, Integer> getCommandsMap() {
        return Collections.unmodifiableMap(new HashMap<String, Integer>() {
            {
                put("goBack", GO_BACK);
                put("loadUrl",LOAD_URL);
                put("reload",RELOAD);
                put("loadJs",LOAD_JS);
            }

        });
    }

    @Override
    public void receiveCommand(WebViewLayout root, int commandId, @Nullable ReadableArray args) {
        switch (commandId){
            case GO_BACK:
                root.goBack();
                break;
            case LOAD_URL:
                root.loadUrl(args.getString(0));
                break;
            case LOAD_JS:
                root.loadUrl("javascript:"+args.getString(0));
                break;
            case RELOAD:
                root.reload();
                break;

        }
    }
}


