package com.lianqin360.aresrctbasic.views.IWebView;

import android.graphics.Canvas;
import android.telecom.Call;
import android.util.AttributeSet;
import android.util.Log;
import android.view.LayoutInflater;
import android.widget.LinearLayout;

import com.facebook.react.bridge.Callback;
import com.facebook.react.uimanager.ThemedReactContext;
import com.lianqin360.aresrctbasic.jsmodules.WebViewJsModule;

/**
 * Created by Spencer on 16/6/20.
 */
public class WebViewLayout extends LinearLayout implements MyWebView.MyWebViewDelegate
{
    private LayoutInflater inflater;
    private LinearLayout wrapper;
    private MyWebView webView;
    private String onPageFinishedListenerKey;
    private String onPageStartedListenerKey;
    private String onProgressChangedListenerKey;
    private String onShouldStartLoadWithRequestListenerKey;
    private String onInvokeListenerKey;
    private ThemedReactContext context;
    public WebViewLayout(ThemedReactContext context) {
        super(context);
        init(context);
    }
    public WebViewLayout(ThemedReactContext context, AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }
    public WebViewLayout(ThemedReactContext context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
    }

    private void init(ThemedReactContext ctx){
        context = ctx;
        webView = new MyWebView(ctx);
        LinearLayout.LayoutParams params =new  LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT,LinearLayout.LayoutParams.MATCH_PARENT);

        addView(webView,params);
        webView.setDelegate(this);
    }
    public void loadUrl (String url){
        webView.loadUrl(url);
    }
    public void loadHtml(String html){
        webView.loadDataWithBaseURL("about:blank", html, "text/html", "utf-8", null);
        //webView.loadUrl("file:///android_asset/webview.html");
        //webView.loadUrl("http://www.qq.com");
        //webView.loadUrl("javascript:document.documentElement.innerHTML = '"+html+"'");
    }
    public void goBack(){
        webView.goBack();
    }
    public void reload(){
        webView.reload();
    }

    public void setOnPageStartedListenerKey(String key) {
        this.onPageStartedListenerKey = key;
    }

    public void setOnProgressChangedListenerKey(String key) {
        this.onProgressChangedListenerKey = key;
    }

    public void setOnShouldStartLoadWithRequestListenerKey(String key) {
        this.onShouldStartLoadWithRequestListenerKey = key;
    }

    public void setOnInvokeListenerKey(String key) {
        this.onInvokeListenerKey = key;
    }

    public void setOnPageFinishedListenerKey(String onPageFinishedListenerKey) {
        this.onPageFinishedListenerKey = onPageFinishedListenerKey;
    }

    @Override
    public void onPageFinished(MyWebView view, String url) {
        if(onPageFinishedListenerKey!=null){
            context.getJSModule(WebViewJsModule.class).invoke(onPageFinishedListenerKey,url);
        }
    }

    @Override
    public void onPageStarted(MyWebView view, String url) {
        if(onPageStartedListenerKey!=null){
            context.getJSModule(WebViewJsModule.class).invoke(onPageStartedListenerKey,url);
        }
    }

    @Override
    public void onProgressChanged(MyWebView view, int newProgress) {
        if(onProgressChangedListenerKey!=null){
            context.getJSModule(WebViewJsModule.class).invoke(onProgressChangedListenerKey,newProgress);
        }
    }

    @Override
    public void onInvoke(Object... args) {
        if(onInvokeListenerKey!=null){
            context.getJSModule(WebViewJsModule.class).invoke(onInvokeListenerKey,args);
        }
    }

    @Override
    public void onShouldStartLoadWithRequest(MyWebView view, String url) {
        if(onShouldStartLoadWithRequestListenerKey!=null){
            context.getJSModule(WebViewJsModule.class).invoke(onShouldStartLoadWithRequestListenerKey,url);
        }
    }
}
