package com.lianqin360.aresrctbasic.views.animation;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

public abstract class AnimationView extends View{

    ScheduledExecutorService mExecutor = Executors.newSingleThreadScheduledExecutor();
    ScheduledFuture<?> mFuture;
    AnimateMessageHandler animateMessageHandler;
    long animateDelay  = 30;
    public AnimationView(Context context) {
        super(context);
        initAnimationView(context);
    }
    public AnimationView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }
    public AnimationView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public abstract void onAnimate(long timestamp,long v);
    public abstract long getNextValue();
    public abstract boolean isFinish();
    private void initAnimationView(Context context){
        animateMessageHandler = new AnimateMessageHandler(this);
    }
    public void startAnimate(){
        mFuture  = mExecutor.scheduleWithFixedDelay(new AnimateTimerTask(this), 0, animateDelay, TimeUnit.MILLISECONDS);
    }
    public void cancelAnimate(){
        if (mFuture != null && !mFuture.isCancelled()) {
            mFuture.cancel(true);
            mFuture = null;
        }
    };
}
