package com.lianqin360.aresrctbasic.views.camera;

/**
 * Created by Spencer on 16/7/7.
 */
import com.facebook.react.uimanager.*;
import com.facebook.react.uimanager.annotations.ReactProp;

public class ReactCameraViewManager extends ViewGroupManager<MyCameraView> {
    private static final String REACT_CLASS = "RCTCamera";

    @Override
    public String getName() {
        return REACT_CLASS;
    }

    @Override
    public MyCameraView createViewInstance(ThemedReactContext context) {
        return new MyCameraView(context);
    }

    @ReactProp(name = "aspect")
    public void setAspect(MyCameraView view, int aspect) {
        view.setAspect(aspect);
    }

    @ReactProp(name = "captureMode")
    public void setCaptureMode(MyCameraView view, int captureMode) {
        // TODO - implement video mode
    }

    @ReactProp(name = "captureTarget")
    public void setCaptureTarget(MyCameraView view, int captureTarget) {
        // No reason to handle this props value here since it's passed again to the ReactCameraManager capture method
    }

    @ReactProp(name = "type")
    public void setType(MyCameraView view, int type) {
        view.setCameraType(type);
    }

    @ReactProp(name = "captureQuality")
    public void setCaptureQuality(MyCameraView view, String captureQuality) {
        view.setCaptureQuality(captureQuality);
    }

    @ReactProp(name = "torchMode")
    public void setTorchMode(MyCameraView view, int torchMode) {
        view.setTorchMode(torchMode);
    }

    @ReactProp(name = "flashMode")
    public void setFlashMode(MyCameraView view, int flashMode) {
        view.setFlashMode(flashMode);
    }

    @ReactProp(name = "orientation")
    public void setOrientation(MyCameraView view, int orientation) {
        view.setOrientation(orientation);
    }

    @ReactProp(name = "captureAudio")
    public void setCaptureAudio(MyCameraView view, boolean captureAudio) {
        // TODO - implement video mode
    }
}
