package com.lianqin360.aresrctbasic.views.loadingui;

import android.graphics.Color;

import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;
import com.facebook.react.uimanager.annotations.ReactProp;

/**
 * Created by Spencer on 16/9/19.
 */
public class ReactCircleProgressBarViewManager extends SimpleViewManager<CircleProgressBar> {
    /**
     * @return the name of this view manager. This will be the name used to reference this view
     * manager from JavaScript in createReactNativeComponentClass.
     */
    @Override
    public String getName() {
        return "RCTCircleProgressBar";
    }

    /**
     * Subclasses should return a new View instance of the proper type.
     *
     * @param reactContext
     */
    @Override
    protected CircleProgressBar createViewInstance(ThemedReactContext reactContext) {
        return new CircleProgressBar(reactContext);
    }
    @ReactProp(name = "process")
    public void setProcess(CircleProgressBar v, float process){
        v.setProcess(process);
    }
    @ReactProp(name = "innerCircleColor")
    public void setInnerCircleColor(CircleProgressBar v, String color){
        v.setInnerCircleColor(Color.parseColor(color));
    }
    @ReactProp(name = "outterCircleColor")
    public void setOutterCircleColor(CircleProgressBar v, String color){
        v.setOutterCircleColor(Color.parseColor(color));
    }
}
