package com.lianqin360.aresrctbasic.views.video;

import android.net.Uri;
import android.support.annotation.Nullable;

import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;
import com.facebook.react.uimanager.annotations.ReactProp;

/**
 * Created by Spencer on 16/7/26.
 */
public class ReactVideoViewManager extends SimpleViewManager<VideoView> {
    /**
     * @return the name of this view manager. This will be the name used to reference this view
     * manager from JavaScript in createReactNativeComponentClass.
     */

    private ThemedReactContext mReactContext;
    @Override
    public String getName() {
        return "RCTVideo";
    }

    /**
     * Subclasses should return a new View instance of the proper type.
     *
     * @param reactContext
     */
    @Override
    protected VideoView createViewInstance(ThemedReactContext reactContext) {
        mReactContext = reactContext;
        return new VideoView(reactContext);
    }
    @ReactProp(name = "src")
    public void setSrc(VideoView view, @Nullable String src) {
//        String uri = "android.resource://" + mReactContext.getPackageName() + "/" + R.raw.start_film;
//        view.setVideoUri(Uri.parse(uri));

    }
    @ReactProp(name = "autoPlay",defaultBoolean = false)
    public void setAutoPlay(VideoView view,boolean autoPlay) {
        view.setAutoPlay(autoPlay);
    }
    @ReactProp(name = "resizeMode")
    public void setResizeMode(VideoLayer videoView, final String resizeModeOrdinalString) {
        // TODO: 16/7/26 待实现
    }

    @ReactProp(name = "repeat", defaultBoolean = false)
    public void setRepeat(VideoView view, boolean repeat) {

        view.setRepeat(repeat);
    }

    @ReactProp(name = "paused", defaultBoolean = false)
    public void setPaused(VideoLayer videoView, boolean paused) {
        // TODO: 16/7/26
    }

    @ReactProp(name = "muted", defaultBoolean = false)
    public void setMuted(VideoView videoView, boolean muted) {
        // TODO: 16/7/26  
    }

    @ReactProp(name = "volume", defaultFloat = 1.0f)
    public void setVolume(VideoView videoView, float volume) {
        // TODO: 16/7/26  
    }

    @ReactProp(name = "seek")
    public void setSeek(VideoView videoView, float seek) {
        //videoView.seekTo(Math.round(seek * 1000.0f));
        // TODO: 16/7/26
    }

    @ReactProp(name = "rate")
    public void setRate(VideoLayer videoView, float rate) {
        // TODO: 16/7/26
    }

    @ReactProp(name = "playInBackground", defaultBoolean = false)
    public void setPlayInBackground(VideoView videoView,boolean playInBackground) {
        // TODO: 16/7/26
    }
}
