package com.lianqin360.aresrctbasic.views.video;

import android.content.Context;
import android.media.MediaPlayer;
import android.net.Uri;
import android.util.Log;
import android.view.Surface;
import android.view.SurfaceHolder;


import java.io.IOException;

/**
 * Created by Spencer on 16/7/26.
 */
public class VideoPlayer implements MediaPlayer.OnCompletionListener, MediaPlayer.OnErrorListener, MediaPlayer.OnInfoListener, MediaPlayer.OnPreparedListener, MediaPlayer.OnSeekCompleteListener, MediaPlayer.OnVideoSizeChangedListener {
    private MediaPlayer player;
    private boolean prepared;
    private boolean autoPlay;
    private boolean repeat;
    private static VideoPlayer mInstance;
    private State state = State.stoped;



    public VideoPlayer(Context context) {
//        player = MediaPlayer.create(context, R.raw.start_film);
//        player.setOnCompletionListener(this);
//        player.setOnErrorListener(this);
//        player.setOnInfoListener(this);
//        player.setOnPreparedListener(this);
//        player.setOnSeekCompleteListener(this);
//        player.setOnVideoSizeChangedListener(this);
//        //player.prepareAsync();
        this.autoPlay = true;
        this.repeat = true;
    }
    public void init(Context context){
//        player = MediaPlayer.create(context, R.raw.start_film);
//        player.setOnCompletionListener(this);
//        player.setOnErrorListener(this);
//        player.setOnInfoListener(this);
//        player.setOnPreparedListener(this);
//        player.setOnSeekCompleteListener(this);
//        player.setOnVideoSizeChangedListener(this);
        //player.prepareAsync();
        this.autoPlay = true;
        this.repeat = true;
    }

    public void setVideoPath(String videoPath) {
        try {
            player.setDataSource(videoPath);
            player.prepareAsync();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }
    public void setVideoUri(final Context context, final Uri uri) {
//        new Thread(new Runnable() {
//            @Override
//            public void run() {
//                try {
//                    player.setDataSource(context,uri);
//                    player.prepareAsync();
//                } catch (IOException e) {
//                    e.printStackTrace();
//                }
//            }
//        }).start();


    }
    public void play() {
        Log.e("onPrepared","play");
        state = State.playing;
        player.start();
    }

    public void pause() {
        if (state.equals(State.playing)) {
            state = State.paused;
            player.pause();
        }
    }

    public void stop() {
        state = State.stoped;
        player.stop();
    }

    public void release() {
        player.stop();
        player.release();
    }

    public void setDisplay(SurfaceHolder holder) {
        player.setDisplay(holder);
    }
    public void setSurface(Surface surface) {
        try{
            player.setSurface(surface);
        }catch (Exception e){
            //Log.e("video view",e.getMessage());
        }

    }

    public void setAutoPlay(boolean autoPlay) {

        this.autoPlay = autoPlay;
    }

    public void setRepeat(boolean repeat) {
        this.repeat = repeat;
    }

    public int getCurrentPosition() {
        return player.getCurrentPosition();
    }

    public int getDuration() {
        return player.getDuration();
    }

    /**
     * Called when the end of a media source is reached during playback.
     *
     * @param mp the MediaPlayer that reached the end of the file
     */
    @Override
    public void onCompletion(MediaPlayer mp) {
        if (repeat) {
            play();
        } else {
            stop();
        }
    }

    /**
     * Called to indicate an error.
     *
     * @param mp    the MediaPlayer the error pertains to
     * @param what  the type of error that has occurred:
     * @param extra an extra code, specific to the error. Typically
     *              implementation dependent.
     * @return True if the method handled the error, false if it didn't.
     * Returning false, or not having an OnErrorListener at all, will
     * cause the OnCompletionListener to be called.
     */
    @Override
    public boolean onError(MediaPlayer mp, int what, int extra) {
        return false;
    }

    /**
     * Called to indicate an info or a warning.
     *
     * @param mp    the MediaPlayer the info pertains to.
     * @param what  the type of info or warning.
     * @param extra an extra code, specific to the info. Typically
     *              implementation dependent.
     * @return True if the method handled the info, false if it didn't.
     * Returning false, or not having an OnErrorListener at all, will
     * cause the info to be discarded.
     */
    @Override
    public boolean onInfo(MediaPlayer mp, int what, int extra) {
        return false;
    }

    /**
     * Called when the media file is ready for playback.
     *
     * @param mp the MediaPlayer that is ready for playback
     */
    @Override
    public void onPrepared(MediaPlayer mp) {
        prepared = true;
        if (autoPlay) {
            play();
        }
    }

    /**
     * Called to indicate the completion of a seek operation.
     *
     * @param mp the MediaPlayer that issued the seek operation
     */
    @Override
    public void onSeekComplete(MediaPlayer mp) {

    }

    /**
     * Called to indicate the video size
     * <p/>
     * The video size (width and height) could be 0 if there was no video,
     * no display surface was set, or the value was not determined yet.
     *
     * @param mp     the MediaPlayer associated with this callback
     * @param width  the width of the video
     * @param height the height of the video
     */
    @Override
    public void onVideoSizeChanged(MediaPlayer mp, int width, int height) {

    }

    public enum State {
        playing("playing"), paused("paused"), stoped("stoped");
        private final String value;

        //构造器默认也只能是private, 从而保证构造函数只能在内部使用
        State(String value) {
            this.value = value;
        }

        public String getValue() {
            return value;
        }
    }

}
