package com.lianqin360.aresrctbasic.views.video;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.PixelFormat;
import android.graphics.Rect;
import android.graphics.SurfaceTexture;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.util.AttributeSet;
import android.util.Log;
import android.view.Surface;
import android.view.SurfaceHolder;
import android.view.TextureView;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.RelativeLayout;


/**
 * Created by Spencer on 16/9/22.
 */
public class VideoView extends FrameLayout implements TextureView.SurfaceTextureListener {
    private Context mContext;
    private  static int id = 1;
    private  VideoLayer videoLayer;
    private VideoPlayer player;
    private int playerId;

    public VideoView(Context context) {
        super(context);
        initView(context);
    }
    public VideoView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }
    public VideoView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    private void initView(Context context){
        mContext = context;

        videoLayer = new VideoLayer(context);
        videoLayer.setSurfaceTextureListener(this);
//        Intent iService=new Intent(context,MainService.class);
//        context.startService(iService);


        //setBackgroundResource(R.mipmap.bg_default_loading);
        addView(videoLayer,new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
    }
    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
    }

    public void setVideoPath(String videoPath) {
        player.setVideoPath(videoPath);
    }
    public void setVideoUri(Uri uri) {
       //player.setVideoUri(mContext,uri);
    }
    public void setAutoPlay(boolean autoPlay){
        //player.setAutoPlay(autoPlay);
    }
    public void setRepeat(boolean repeat){
//        player.setRepeat(repeat);
    }


    /**
     * Invoked when a {@link TextureView}'s SurfaceTexture is ready for use.
     *
     * @param surface The surface returned by
     *                {@link TextureView#getSurfaceTexture()}
     * @param width   The width of the surface
     * @param height  The height of the surface
     */
    @Override
    public void onSurfaceTextureAvailable(SurfaceTexture surface, int width, int height) {
       // player = MainService.getNewVideoPlayer();
        Surface s = new Surface(surface);
        player.setSurface(s);
    }

    /**
     * Invoked when the {@link SurfaceTexture}'s buffers size changed.
     *
     * @param surface The surface returned by
     *                {@link TextureView#getSurfaceTexture()}
     * @param width   The new width of the surface
     * @param height  The new height of the surface
     */
    @Override
    public void onSurfaceTextureSizeChanged(SurfaceTexture surface, int width, int height) {

    }

    /**
     * Invoked when the specified {@link SurfaceTexture} is about to be destroyed.
     * If returns true, no rendering should happen inside the surface texture after this method
     * is invoked. If returns false, the client needs to call {@link SurfaceTexture#release()}.
     * Most applications should return true.
     *
     * @param surface The surface about to be destroyed
     */
    @Override
    public boolean onSurfaceTextureDestroyed(SurfaceTexture surface) {
        Log.e("TBJ","onSurfaceTextureDestroyed ");
        player.stop();
        player.release();
//        Intent iService=new Intent(mContext,MainService.class);
//        iService.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//        mContext.stopService(iService);
        return false;
    }

    /**
     * Invoked when the specified {@link SurfaceTexture} is updated through
     * {@link SurfaceTexture#updateTexImage()}.
     *
     * @param surface The surface just updated
     */
    @Override
    public void onSurfaceTextureUpdated(SurfaceTexture surface) {

    }
}
