//
//  RCTNative.m
//  m
//
//  Created by Spencer on 16/7/28.
//  Copyright © 2016年 Facebook. All rights reserved.
//

#import "RCTNativeMethodsManager.h"


@implementation RCTNativeMethodsManager
{
  RCTMediaViewHelper *mediaViewController;
}

-(id)init{
  self = [super init];
  if(self){
    mediaViewController =  [[RCTMediaViewHelper alloc]init];
  }
  return self;
}
RCT_EXPORT_MODULE(NativeMethodsManager);
RCT_EXPORT_METHOD(openPhotoGallery:(RCTResponseSenderBlock )callback){
    [mediaViewController openPhotoGallery:callback];
}
RCT_EXPORT_METHOD(openVideoGallery:(RCTResponseSenderBlock )callback){
    [mediaViewController openVideoGallery:callback];
}
RCT_EXPORT_METHOD(openCamera:(RCTResponseSenderBlock )callback){
    [mediaViewController openCamera:callback];
}
RCT_EXPORT_METHOD(openVideo:(RCTResponseSenderBlock )callback){
    [mediaViewController openVideo:callback];
}

RCT_EXPORT_METHOD(changeStatusBarStyle:(NSString *)style)
{
  if([style isEqualToString:@"light"]){
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    //设置状态栏为白色
  }else{
    //设置状态栏为黑色
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleDefault;
  }
}

//拨打客服电话
RCT_EXPORT_METHOD(callTo:(NSString *)string){
  NSString *allString = [NSString stringWithFormat:@"tel:%@",string];
  [[UIApplication sharedApplication] openURL:[NSURL URLWithString:allString]];
}

//发送Email
RCT_EXPORT_METHOD(mailTo:(NSString *)string){
      NSMutableString *mailUrl = [[NSMutableString alloc] init];
      //添加收件人：
      NSArray *toRecipients = @[string];
      // 注意：如有多个收件人，可以使用componentsJoinedByString方法连接，连接符为@","
      [mailUrl appendFormat:@"mailto:%@", toRecipients[0]];
       NSString *emailPath = [mailUrl stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
      [[UIApplication sharedApplication] openURL:[NSURL URLWithString:emailPath]];

}

RCT_EXPORT_METHOD(isInstalled:(NSString *)urlScheme callback:(RCTResponseSenderBlock )callback){
  BOOL isInstaled = [[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:urlScheme]];
  if(isInstaled){
    callback(@[@YES]);
  }else{
    callback(@[@NO]);
  }
}
RCT_EXPORT_METHOD(openApplication:(NSString *)urlScheme){
  NSURL *url  = [NSURL URLWithString:urlScheme];
  [[UIApplication sharedApplication] openURL:url];
}
RCT_EXPORT_METHOD(openAppStore:(NSString *)appleUrl){
  
//  if ([UIDevice isIOS7]) {
//    NSString *str = [NSString stringWithFormat:@"itms-apps://itunes.apple.com/app/id%@",appleID];
//    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:str]];
//  } else {
    NSString *str = [NSString stringWithFormat:@"itms-apps://%@", appleUrl];
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:str]];
  //}
}

@end
