//
//  MyCookieManager.m
//  m
//
//  Created by Spencer on 16/6/29.
//  Copyright © 2016年 Facebook. All rights reserved.
//

#import "MyCookieManager.h"

@implementation MyCookieManager

/*
 // Only override drawRect: if you perform custom drawing.
 // An empty implementation adversely affects performance during animation.
 - (void)drawRect:(CGRect)rect {
 // Drawing code
 }
 */
NSHTTPCookieStorage *cookieJar;
-(id) init{
  cookieJar = [NSHTTPCookieStorage sharedHTTPCookieStorage];
  return self;
}
-(void)setCookie:(NSString *)url name:(NSString *)name value :(NSString *)value{
  NSMutableDictionary *cookieProperties = [NSMutableDictionary dictionary];
  [cookieProperties setObject:name forKey:NSHTTPCookieName];
  [cookieProperties setObject:value forKey:NSHTTPCookieValue];
  [cookieProperties setObject:url forKey:NSHTTPCookieDomain];
  [cookieProperties setObject:url forKey:NSHTTPCookieOriginURL];
  [cookieProperties setObject:@"/" forKey:NSHTTPCookiePath];
  [cookieProperties setObject:@"0" forKey:NSHTTPCookieVersion];
  [cookieProperties setObject:@"0" forKey:NSHTTPCookieExpires];
  
  NSHTTPCookie *cookie = [NSHTTPCookie cookieWithProperties:cookieProperties];
  [cookieJar setCookie:cookie];
}
-(void)removeAllCookie{
  NSArray *_tmpArray = [NSArray arrayWithArray:[cookieJar cookies]];
  for (id obj in _tmpArray) {
    [cookieJar deleteCookie:obj];
  }
}
-(void)removeSessionCookie{
  
}
-(void)setAcceptCookie:(BOOL *)isAccept{
  if(isAccept){
    [cookieJar setCookieAcceptPolicy:NSHTTPCookieAcceptPolicyAlways];
  }else{
    [cookieJar setCookieAcceptPolicy:NSHTTPCookieAcceptPolicyNever];
  }
  
}
-(NSDictionary *)cookies{
  NSArray * cookies = cookieJar.cookies;
  return [self parseCookies:cookies];
  
}
-(NSDictionary *)cookiesForURL:(NSString *)url{
  NSArray * cookies = cookieJar.cookies;
  NSMutableArray * result = [[NSMutableArray alloc] init];

  for (NSHTTPCookie *cookie in cookies) {
    if([cookie.domain isEqualToString:url]){
      [result addObject:cookie];
    }
  }
  return [self parseCookies:result];
}
-(void)syncCookie{
}
-(NSDictionary *)parseCookies:(NSArray<NSHTTPCookie *>*)cookies{
  NSMutableDictionary *result = [NSMutableDictionary dictionaryWithCapacity:cookies.count];
  
  for (NSHTTPCookie *cookie in cookies) {
    NSDictionary*  parsedCookie = [NSDictionary dictionaryWithObjectsAndKeys:
                                   cookie.domain,@"domain",
                                   cookie.name,@"name",
                                   cookie.value,@"value",
                                   [NSNumber numberWithInteger:cookie.version],@"version",
                                   cookie.expiresDate,@"expires",
                                   cookie.path,@"path",
                                   cookie.commentURL.absoluteString,@"url",
                                   nil
                                   ];
    [result setObject:parsedCookie forKey:cookie.name];
  }
  return result;
}
@end
