/**
 * Copyright (c) 2015-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

#import <JavaScriptCore/JavaScriptCore.h>

#import <UIKit/UIKit.h>

#import <React/RCTAutoInsetsProtocol.h>
#import <React/RCTUtils.h>
#import <React/RCTView.h>
#import <React/RCTConvert.h>
#import <React/RCTBridge.h>


@interface AresWebView : RCTView<UIWebViewDelegate>

@property (nonatomic, copy) NSDictionary *source;
@property (nonatomic, assign) UIEdgeInsets contentInset;
@property (nonatomic, assign) BOOL automaticallyAdjustContentInsets;
@property (nonatomic, copy) NSString *injectedJavaScript;
@property (nonatomic, assign) BOOL scalesPageToFit;
@property (nonatomic, assign) RCTBridge *bridge;


@property (nonatomic, copy) RCTDirectEventBlock onInvokeKey;
@property (nonatomic, copy) RCTDirectEventBlock onPageFinishedKey;
@property (nonatomic, copy) RCTDirectEventBlock onPageStartedKey;
@property (nonatomic, copy) RCTDirectEventBlock onProgressChangedKey;
@property (nonatomic, copy) RCTDirectEventBlock onShouldStartLoadWithRequestKey;

- (void)goForward;
- (void)goBack;
- (void)reload;
- (void)loadJs:(NSString *)jsString;
- (void)loadUrl:(NSString *)url;

@end

