/**
 * @description - fileutil
 */
'use strict'
import mine from './mime';
function getFileExtName(filename) {
    var reg = /([^\.]+$)/ig;
    if(reg.test(filename)){
        return RegExp.$1;
    }
    return '*';
}
function getFileType(filename) {
    var type = getFileExtName(filename).toLowerCase();
    if(mine[type]){
        return mine[type];
    }else{
        return 'application/octet-stream';
    }
}
function getFileNameByUri(uri) {
    var reg = /([^\/]*$)/ig;
    if(reg.test(uri)){
        return RegExp.$1;
    }
    return '*';
}
export default {
    create(uri,name){
        name = name || getFileNameByUri(uri);
        let type = getFileType(name);
        return {
            type:type,
            uri:uri,
            name:name
        }
    }
}