'use strict'
import { EventEmitter } from 'ares-util';
import HttpEntity from './HttpEntity';
import HttpEvent from './HttpEvent';
function noop(prama) {
    return prama;
};
function requestFinishHandle(http) {

}
export default class Http extends EventEmitter {
    constructor() {
        super();
        this.timeout = Http.timeout;
        this.connectCount = 0;
        this.successFilter = noop;
        this.errorFilter = noop;
        this.timeoutFilter = noop;
        this.connectBound = 10;
        this.cache = [];
        this.httpEntity;
    }
    _requestFinish(httpEntity,request,response) {
        this.connectCount--;
        Http.connectCount--;
        if (this.cache.length > 0) {
           setTimeout(this.cache.shift(),0);
        }
        var event = new HttpEvent(HttpEvent.REQUEST_FINISH,HttpEvent.COMPLETED,httpEntity,request,response,'request finished',this);
        this.emit(HttpEvent.REQUEST_FINISH,event);

    }
    
    _requestBeigin(httpEntity,request,response){
        Http.connectCount++;
        this.connectCount++;
        var event = new HttpEvent(HttpEvent.REQUEST_BEGIN,HttpEvent.INTERACTIVE,httpEntity,request,response,'sending request',this);
        this.emit(HttpEvent.REQUEST_BEGIN,event);
    }
    
    http(request,bundle = {}) {
       
        return new Promise((resolve, reject) => {
            var _request = request;
            var httpEntity = new HttpEntity(_request, { ...bundle,timeout: this.timeout });
             var sendRequest = ()=>{
                this._requestBeigin(httpEntity,request,null);
                this.httpEntity = httpEntity;
                return httpEntity.sendRequest().then((response) => {
                    this.httpEntity = httpEntity;
                    if (response.ok) {
                        return response.text().then((content) => {
                            this.emit('requestSuccess', response);
                            this._requestFinish(httpEntity,request, response);
                            try {
                                content = JSON.parse(content);
                            } catch (e) {
                            }
                            resolve(content);
                        });
                    } else {
                        this._requestFinish(httpEntity,request, response);
                        reject(response);
                    }
                }, (response) => {
                    this.httpEntity = httpEntity;
                    this._requestFinish(httpEntity,request, response);
                    reject(response);
                }).catch(error => {
                    this.httpEntity = httpEntity;
                    this._requestFinish(httpEntity,request, {ok:false,error:error});
                    reject(response);
                });
            }
            if (this.connectCount <= this.connectBound) {
                return sendRequest();
            } else {
                this.cache.push(sendRequest);
            }
        });
    }
    post(url, prama = {}, headers = {},bundle = {}) {
        var body;
        var headers = new Headers(headers);
        for (let key in prama) {
            body = body || new FormData();
            if (prama.hasOwnProperty(key)) {
                let v = prama[key];
                //修复null bug
                if (prama[key] instanceof(Object) && !prama[key].uri) {
                    v = JSON.stringify(prama[key]);
                }
                body.append(key, v);
            }
        }
        let request = new Request(url, { method: 'post', body, credentials: 'include', mode: "FormData", headers });
        return this.http(request,bundle);
    }
    get(url, prama = {}, headers = {},bundle = {}) {
        var keys = [];
        var headers = new Headers(headers);
        for (var key in prama) {
            if (prama.hasOwnProperty(key)) {
                keys.push(key + '=' + prama[key]);
            }
        }
        if (keys.length) {
            url = url + '?' + keys.join('&');
        }
        var request = new Request(url, { method: 'get', credentials: 'include', headers });
        return this.http(request,bundle);
    }
}
Http.timeout = 90000;//超时
Http.connectCount = 0;