'use strict'
import React, {Component} from 'react';
import {
   StyleSheet,
   View,
   Text,
   Image,
   TouchableOpacity,
   ScrollView,
   InteractionManager,
}  from 'react-native';
import PropTypes from 'prop-types';

import WebView from './WebView';

function wrapHtml(content,webviewId,width){
    var html = '<!DOCTYPE html>'
                    + '<html style="font-size: 11.75px; background: #fff;overflow:hidden;-webkit-overflow-scrolling: touch;">'
                    +    '<head>'
                    +        '<meta charset="UTF-8">'
                    +        '<meta name="viewport" content="width='+width+',minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">'
                    +        '<meta name="apple-mobile-web-app-capable" content="yes" />'
                    +        '<meta name="apple-mobile-web-app-status-bar-style" content="black" />'
                    +        '<meta content="yes" name="apple-mobile-web-app-capable">'
                    +        '<meta content="black" name="apple-mobile-web-app-status-bar-style">'
                    +        '<meta content="telephone=no" name="format-detection">'
                    +        '<meta content="email=no" name="format-detection">'
                    +        '<style>*{padding:0;margin:0}</style>'
                    +    '</head>'
                    +    '<body style="background: #FFF;margin:0 auto;padding:0;overflow:hidden;width:'+(width)+'px">'
                    +       '<div style="margin:0 auto;padding:0">'
                    +           content
                    +        '</div>'
                    +        '<script>'
                    +           '('+getSizeOfHtml.toString()+')('+webviewId+')'
                    //+           ';getSizeOfHtml();'
                    +        '</script>'
                    +    '</body>'
                    +'</html>';
        return html;
}
function getSizeOfHtml(webViewId){
    var imgs = document.getElementsByTagName('img');
    var height = document.body.scrollHeight;
    if(imgs){
        for(var i = 0;i<imgs.length;i++){
            imgs[i].style.maxWidth = '100%';
            imgs[i].onload = function(){
            var height = document.body.scrollHeight;
            try{
                _MyWebView.invoke("getSizeOfHtml"+webViewId,JSON.stringify({height:height}));
            }catch(e){
                //document.body.innerHTML = e.message;
                }
            }
        }
    }
    try{
        _MyWebView.invoke("getSizeOfHtml"+webViewId,JSON.stringify({height:height}));
    }catch(e){
        //document.body.innerHTML = e.message;
    }
    window.onload = function(){
        setTimeout(function(){
            var height = document.body.clientHeight;             
            try{
                _MyWebView.invoke("getSizeOfHtml"+webViewId,JSON.stringify({height:height}));
            }catch(e){
               // document.body.innerHTML = e.message;
            }
        },0)

    }   
}
var id = 1;

export default class HTMLView extends Component{
    constructor(...props) {
        super(...props);
        this.state = {
            webViewHeight:0,
            webViewWidth:0,
            isMount:false
        }
        this.id = id++;
        
    }
    componentDidMount() {
       this.state.isMount = true;
       WebViewJsModule.register({
            ['getSizeOfHtml'+this.id]:(size)=>{
                let height = JSON.parse(size).height;
                this.setState({webViewHeight:height})
            }
        });
   }
   componentWillUnmount() {
       WebViewJsModule.release('getSizeOfHtml'+this.id);
       this.state.isMount = false;
   }
    render(){
        return <WebView 
                onLayout = {(e)=>{
                    let {width} = e.nativeEvent.layout;
                    if(width!=this.state.webViewWidth){
                        this.setState({webViewWidth:width});
                    }
                }}
                {...this.props} 
                style = {[this.props.style,{height:this.state.webViewHeight}]}
                source = {{html:this.state.webViewWidth!=0&&wrapHtml(this.props.value,this.id,this.state.webViewWidth)||''}}/>
    }
}