/**
 * @description - android picker
 */
'use strict'
import React, { Component } from 'react'
import {
    View,
    Picker,
    requireNativeComponent,
    ViewPropTypes
}  from 'react-native';
import PropTypes from 'prop-types';

var Item = Picker.Item;
export default class IPickerAndroid extends Component {
    constructor(...props) {
        super(...props);
        this._lastNativePosition = 0;
        this.state = this._stateFromProps(this.props);

    }

    componentWillMount() {
    }
    componentDidMount() {
    }
    
    componentDidUpdate() {
        // The picker is a controlled component. This means we expect the
        // on*Change handlers to be in charge of updating our
        // `selectedValue` prop. That way they can also
        // disallow/undo/mutate the selection of certain values. In other
        // words, the embedder of this component should be the source of
        // truth, not the native component.
        // if (this._rctPicker && this.state.selectedIndex !== this._lastNativePosition) {
        //     this._rctPicker.setNativeProps({ selectedIndex: this.state.selectedIndex });
        //     this._lastNativePosition = this.state.selectedIndex;
        // }
    }
    componentWillReceiveProps(nextProps) {
        this.setState(this._stateFromProps(nextProps));
    }
    // Translate prop and children into stuff that the native picker understands.
    _stateFromProps(props) {
        var selectedIndex = 0;
        let keys = [];
        let items = React.Children.map(props.children, (child, index) => {
            if (child.props.value == props.selectedValue) {
                selectedIndex = index;
            }
            keys.push(child.props.value);
            return child.props.label;
        });
        return { selectedIndex, items, keys };
    }
    _onChange(event) {
        event.nativeEvent.value = this.state.keys[event.nativeEvent.index];
        //this._rctPicker.setNativeProps({ selectedIndex: this.state.selectedIndex });
        this.props.onChange && this.props.onChange(event);
        this.props.onValueChange && this.props.onValueChange(event.nativeEvent.value);
    }
    render() {
        var nativeProps = {
            items: this.state.items,
            onChange: (event) => this._onChange(event),
            selectedIndex: this.state.selectedIndex,
            style: [{height:300,flex:1},this.props.style],
        };
        return (
            <RCTIPicker
                {...nativeProps}
                ref={(ref) => { this._rctPicker = ref; } }
                />
        );
    }

}
IPickerAndroid.Item = Item;
IPickerAndroid.propTypes = {
    ...ViewPropTypes,
    items: PropTypes.array,
    selectedIndex: PropTypes.number,
    selectedValue: PropTypes.string,
    onValueChange: PropTypes.func
}
IPickerAndroid.defaultProps = {
}
var RCTIPicker = requireNativeComponent('RCTIPickerAndroid', IPickerAndroid, {
    nativeOnly: { onChange: true,items:true }
});
