/**
 * @description - $(currentFile)
 */
'use strict'
import React, { Component } from 'react';
import {
    StyleSheet,
    View,
    Text,
    Modal
} from 'react-native';
import Alert from './Alert';
import Toast from './Toast';
import Pack from './Pack';
import SceneComponent from './SceneComponent';
import PropTypes from 'prop-types';

const PACK_PREFIX = 'PACK_PREFIX_';
var ID = 1;
export default class Screen extends SceneComponent {
    constructor(...props) {
        super(...props);
        this.state = {
            views: []
        }
        this._readyList = [];
        this._isReady = false;
    }
    _ready(callback) {
        if (this._isReady) {
            callback();
        } else {
            this._readyList.push(callback);
        }
    }
    _fireReadyList() {
        var callback = this._readyList.shift();
        while (callback) {
            callback();
            callback = this._readyList.shift();
        }
    }
    shouldComponentUpdate(nextProps, nextState) {
        return this.isFocused();
    }
    isFocused() {
        return true;
    }
    componentDidUpdate(prevProps, prevState) {

    }
    componentDidMount() {
        this._isReady = true;
        this._fireReadyList();
    }

    reload() {

    }
    alert(config) {
        this._ready(() => this.refs.alert.show(config));
    }
    toast(message, callback, timeout) {
        this._ready(() => this.refs.toast.show(message, callback, timeout));
    }
    showContent(content) {
        var id = PACK_PREFIX + (++ID) ;
        content.id = id;
        this._ready(() => {
            this.refs.pack.showContent(content);
        })
        return id;
    }
    hideContent(id) {
        this._ready(() => {
            this.refs.pack.hideContent(id);
        })
    }
    render() {
        return (
            <View collapsable={true} style={{ flex: 1, flexDirection: 'column' }}>
                <View
                    collapsable={true}
                    style={{ flex: 1, flexDirection: 'column' }}>
                    {this.props.children}
                </View>
                <Pack ref='pack' />
                <Alert ref='alert' />
                <Toast ref='toast' />
            </View>
        );
    }
}
Screen.propTypes = {

}