/**
 * @filename - app/react/views/SwitchAndroid.js
 * @description - Android仿ios Switch
 */
'use strict'
import React, { Component } from 'react';
import {
    View,
    requireNativeComponent,
    ViewPropTypes
}  from 'react-native';
import PropTypes from 'prop-types';
class Switch extends Component {
    constructor(...props) {
        super(...props);
    }
    _onChange(event) {
        this._rctSwitch.setNativeProps({ value: this.props.value });
        this.props.onChange && this.props.onChange(event);
        this.props.onValueChange && this.props.onValueChange(event.nativeEvent.value);
    }
    render() {
        var props = {...this.props };
        props.onStartShouldSetResponder = () => true;
        props.onResponderTerminationRequest = () => false;
        return (
            <RCTSwitch
                {...props}
                style = {[{height: 31,width: 51},props.style]}
                ref={(ref) => { this._rctSwitch = ref; } }
                onChange={(e) => this._onChange(e) }
                />
        );
    }

}
Switch.propTypes = {
    ...ViewPropTypes,
    value: PropTypes.bool,
    disabled: PropTypes.bool,
    onValueChange: PropTypes.func,
    tintColor: PropTypes.string,
    onTintColor: PropTypes.string,
    thumbTintColor: PropTypes.string,
}
Switch.defaultProps = {
    disabled: false,
    tintColor:'#FFFFFF',
    onTintColor:'#329DFF'
}
var RCTSwitch = requireNativeComponent('RCTSwitchAndroid', Switch, {
    nativeOnly: { onChange: true }
});

export default Switch;