/*
 * @file - app/react/views/Video.js
 * @description - 视频播放
 */
import React,{Component} from 'react';
import {requireNativeComponent,View,ViewPropTypes} from 'react-native';
import resolveAssetSource from 'resolveAssetSource';
import PropTypes from 'prop-types';
var id = 0;
export default class Video extends Component{
    constructor(...props){
        super(...props);
    }
    
    componentWillMount() {
        this.id = id++;
    }
    
    componentDidMount() {
    }
    _onPlayerPrepared(event){

    }
    render(){
        var source = resolveAssetSource(this.props.source);
        return (
            <RCTVideo 
                ref = {(v)=>this.player = v}
                {...this.props}
                src = {source.uri}/>
        );
    }
}
Video.propTypes = {
    ...ViewPropTypes,
    source:PropTypes.oneOfType([
      PropTypes.shape({
        uri: PropTypes.string,
      }),
      PropTypes.number,
    ]),
    src:PropTypes.string,
    autoPlay:PropTypes.bool,
    resizeMode:PropTypes.string,
    repeat:PropTypes.bool,
    muted:PropTypes.bool,
    paused:PropTypes.bool,
    volume:PropTypes.number,
    seek:PropTypes.number,
    rate:PropTypes.number,
    playInBackground:PropTypes.bool

}
const RCTVideo = requireNativeComponent('RCTVideo', Video);
