/**
 * @description - CheckBox
 */
'use strict'
import React, { Component } from 'react';
import {
    StyleSheet,
    Text,
    View,
    Image,
    TouchableOpacity
} from 'react-native';
import PropTypes from 'prop-types';

var icons = [
    require('./check_checkbox_n.png'),
    require('./check_checkbox_p.png'),
    require('./check_checkbox_n.png'),
    require('./check_checkbox_up.png')];

export default class CheckBox extends Component {
    constructor(...props) {
        super(...props);
        var initValue = this.props.initValue;
        if(this.props.value!==undefined){
            initValue = this.props.value;
        }
        this.state = {
            value:initValue
        }
    }
    componentWillReceiveProps(nextProps) {
        if(nextProps.value!=this.props.value){
            this.state.value = nextProps.value;
        }
    }
    
    _check() {
        this.setState({
            value: !this.state.value
        }, () => {
            !this.props.disabled && this.props.onValueChange && this.props.onValueChange(this.state.value);
        });
    }
    render() {
        var value = this.state.value && 1 || 0;
        var disabled = this.props.disabled && 2 || 0;
        var index = value + disabled;
        var icons = this.props.icons
        return (
            <TouchableOpacity
                activeOpacity={1}
                onPress={() => this._check()}>
                <Image
                    style={[this.props.style]}
                    source={icons[index]} />
            </TouchableOpacity>
        );
    }
}
CheckBox.propTypes = {
    onValueChange: PropTypes.func,
    value: PropTypes.bool,
    disabled: PropTypes.bool,
    icons: PropTypes.array
}
CheckBox.defaultProps = {
    initValue: false,
    icons: icons
}